// Initialization for all layout views
// You can use the variables app and view, and the shared code namespaces if you have some

// For developers to figure out what they can use
console.log('app:');
console.log(app);
// console.log('shared code:');
// console.log(shared);
console.log('view:');
console.log(view);

// Prepare UI
view.container.hide();

// Change page title and add ebin grafixx
view.dom.image.attr('src', proot.link.images.show('images/users/jerry.jpg', 300)).attr('alt', 'Eisk').attr('title', 'Eisk');

// Fetch & populate content
view.dom.title.populate(app.meta.name);
p.contact.files.get('data/content/home.json').then(function(data) {
	view.dom.content.populate(data.content);
});

// Populate profile list
view.dom.profiles.hide();
p.contact.database.list('profiles', 10).then(function (profiles) {
	
	var items = [];

	// Iterate through projects
	var keys = Object.keys(profiles).sort();
	for (var i = 0; i < keys.length; i++) {
		var id = keys[i];
		var profile = profiles[id];

		var name = $('<dt />').text(profile.title + ' (' + id + ')');

		var description = '';
		if (!is.empty(profile.description)) {
			description = $('<dd />').text(profile.description);
		}

		items.push(name.outerHtml() + (!is.empty(description) ? description.outerHtml() : ''));

	}

	// Show items
	view.dom.profiles.html(items.reverse().join('')).fadeIn(200);
	view.status.resolve();

// Error handling
}, function (errors) {
	view.status.resolve();
});
