{

	submits: function (container) {
		$('form a.submit, form input[type="submit"]', container).bind('click', function (event) {
			event.preventDefault();
			$(this).parents('form').submit();
		});

        // Pressing enter submits forms
		$('form .submit, form input, form select', container).bind('keydown', function (event) {
            if (event.which === 13 && !event.shiftKey) {
				event.preventDefault();
				$(this).parents('form').submit();
			}
		});

        // Pressing shift + enter in textareas submits forms
		$('form textarea', container).bind('keydown', function (event) {
            if (event.which === 13 && event.shiftKey) {
				event.preventDefault();
				$(this).parents('form').submit();
			}
		});

	},

	links: function (container) {

		// Handle links globally
		$('a', container).bind('click', function (event) {

			if (event.which != 2 && !event.metaKey) {

				var link = $(this);
				var target = link.attr('href');

				// External links
				if (p.text.matches(target, 'url') || link.hasClass('external')) {
					link.attr('target', '_blank');

				// E-mail addresses
				} else if (p.text.matches(target, 'email')) {
					link.attr('target', '_blank');
					link.attr('href', 'mailto:' + target);

				}

			}

		});

	}
	
}