{

	unrender: function (view) {
		var dfd = $.Deferred();
		view.dom.images.children().fadeOut(100, function () {
			$(this).remove();
			dfd.resolve();
		});
		return dfd.promise();
	},

	render: function (view, list) {

		var dfd = $.Deferred();

		// Create a list item for each image
		var clones = '';
		for (var i = 0; i < list.length; i++) {
			var filename = list[i];
			var clone = view.dom.skeleton.image.clone();
			var image = clone.find('img');
			
			// We'll show the image later
			image.addClass('hidden');

			// Populate links
			image.populate(p.link.images.show(app.settings.uploadPath + filename, 250, 250, -1), filename);
			clone.find('a').populate(p.link.images.show(app.settings.uploadPath + filename)).attr('rel', filename);

			// Add to list of added images
			clones = clones + p.html.raw(clone[0]);

		}

		// Throw the pics in
		view.dom.images.html(clones);

		// Resolve now, images will come later
		dfd.resolve();

		// Render images in gracefully
		p.dom.select('image', view.dom.images).each(function () {
			var image = $(this);
			image.imagesLoaded().then(function () {
				image.fadeIn(150, function () {
					image.removeClass('hidden');
				});
			});
		});

		return dfd.promise();
	}
	
}