{

	populate: function (view) {

		var dfd = $.Deferred();

		// Make sure image is done for
		var _hideImage = function (image) {
			var stopper = $.Deferred();

			// Image is already hidden
			if (p.dom.is.hidden(image)) {
				stopper.resolve();

			// Hide gracefully
			} else {
				image.fadeOut(50, function () {
					stopper.resolve();
				});
			}

			return stopper.promise();
		};



		// Keep content up to date
		p.app.memory.update('current', view.content);

		// Include some text details immediately
		view.dom.title.text(view.content);
		view.dom.links.populate(p.link.images.show(app.settings.uploadPath + view.content));

		// Disable or enable navigation
		var current = p.app.memory.get('current');
		var images = p.app.memory.get('images');
		if (bl.are.equal(current, bl.find.first.value(images))) {
			view.dom.navigation.previous.disable();
		} else {
			view.dom.navigation.previous.enable();
		}
		if (bl.are.equal(current, bl.find.last.value(images))) {
			view.dom.navigation.next.disable();
		} else {
			view.dom.navigation.next.enable();
		}



		// Prepare the image
		_hideImage(view.dom.image).then(function () {

			// Image details
			view.dom.image.populate(p.link.images.show(app.settings.uploadPath + view.content, 700, 700, -1), view.content);

			// Render image gracefully
			view.dom.image.imagesLoaded().always(function () {
				view.dom.image.fadeIn(100);
			});
			
			dfd.resolve();
			
		});

		return dfd.promise();
	}

}