
// Image will be rendered in later
view.dom.image.hide();

// Navigation links & keyboard shortcuts
view.dom.navigation.all.bind('click', function (event) {
	event.preventDefault();

	var link = $(this);

	// Count next and previous values for enabled links
	if (p.dom.is.enabled(link)) {

		var images = p.app.memory.get('images');
		var current = bl.find.value(p.app.memory.get('current'), images)[0];
		var next = current+1;
		var previous = current-1;

		// Navigate
		var image;
		if (link.hasClass('next') && next < bl.get.length(images)) {
			image = images[next];
			p.state.to.view({wrapper: '.wrapper_splash', type: 'splash', view: 'image', content: image}, 'show/' + image, undefined, true);
		} else if (link.hasClass('previous') && previous >= 0) {
			image = images[previous];
			p.state.to.view({wrapper: '.wrapper_splash', type: 'splash', view: 'image', content: image}, 'show/' + image, undefined, true);
		}
	}

});

// FLAG repetition
Mousetrap.bind(['left', 'up'], function() {
	var images = p.app.memory.get('images');
	var current = bl.find.value(p.app.memory.get('current'), images)[0];
	var previous = current-1;
	if (previous >= 0) {
		var image = images[previous];
		p.state.to.view({wrapper: '.wrapper_splash', type: 'splash', view: 'image', content: image}, 'show/' + image, undefined, true);
	}
});
Mousetrap.bind(['right', 'down'], function() {
	var images = p.app.memory.get('images');
	var current = bl.find.value(p.app.memory.get('current'), images)[0];
	var next = current+1;
	if (next < bl.get.length(images)) {
		var image = images[next];
		p.state.to.view({wrapper: '.wrapper_splash', type: 'splash', view: 'image', content: image}, 'show/' + image, undefined, true);
	}
});


// Use the current image as fallback
if (bl.is.empty(view.content)) {
	view.content = p.app.memory.get('current');
}

// A valid image requested
if (bl.has.value(view.content, p.app.memory.get('images'))) {
	shared.splash.image.populate(view).then(function () {
		view.status.resolve();
	});

// FLAG rejections aren't handled at all, but I'd like to be able to do this
} else {
	view.status.reject(404);
}
