
// Don't close popup when handling fake file input
$('.file strong', view.container).bind('click', function (event) {
	event.stopPropagation();
});

// Form's states
var form = {

	start: function () {
		view.dom.submit.disable();
		view.dom.name.css('opacity', 0);
		view.dom.submit.css('opacity', 0);
	},

	unselected: function () {
		view.dom.submit.disable();
		view.dom.submit.fadeTo(100, 0, function () {
			view.dom.name.fadeTo(200, 0);
		});
	},

	selected: function () {
		view.dom.submit.enable();
		view.dom.name.fadeTo(300, 1);
		view.dom.submit.fadeTo(300, 1);
	}

};

view.dom.title.populate(app.meta.description);

// Prepare form
view.dom.form.attr('action', p.link.images.upload());

// Trigger file selection automatically (doesn't work on all browsers)
form.start();
view.dom.file.click();

// Change fake file input button
var original = view.dom.fileButton.html();
view.dom.file.bind('change', function () {
	var value = view.dom.file.extract();

	// Value is empty
	if (bl.is.empty(value)) {
		view.dom.fileButton.populate(original);
		form.unselected();

	// File selected
	} else {
		var text = bl.find.last.value(value.split('\\'));
		view.dom.fileButton.populate(text);
		form.selected();
	}

});

// Form submission
view.dom.form.bind('submit', function (event) {
	event.preventDefault();
	
	// Create the data (NOTE the file will be picked by ajax())
	var data = {
		name: view.dom.name.extract(),
		path: app.settings.uploadPath
	};

	// Prevalidation
	if (!bl.is.empty(p.dom.select('file', view.dom.form).extract())) {

		// Disable form controls
		view.dom.name.disable();
		view.dom.submit.disable();
		view.dom.loading.enable();

		// Submit info to action
		// NOTE built-in Proot methods do not support the iframe-transport plugin, so I'm using raw $.ajax()
		$.ajax(p.link.images.upload(), {
			type: 'POST',
			dataType: 'json',
			data: data,
			files: p.dom.select('file', view.dom.form),
			iframe: true,
			processData: false

		// AJAX uploads are tricky, error/success callbacks are the same here
		}).always(function (response) {
			view.dom.submit.enable();
			view.dom.name.enable();
			view.dom.loading.disable();

			// Close splash, update grid
			// FLAG I'm relying on grid having been loaded to app container
			app.container.update();
			p.state.to.previous();

		});

	}

});
