<?php
// Returns behavior files from app and tools as valid JS
// FLAG
//    - Hardly elegant
//    - JS side expects what's hardcoded here - this should be declared somewhere, somehow
function behavior_to_js ($child, $root, $path = '') {

	global $app;
	global $constants;
	global $p;
	$return = '';

	// Compose the namespace string
	$temp = explode('/', $path, -1);
	unset($temp[0]);
	if (!empty($temp)) {
		$namespace = '.children.'.implode('.children.', $temp);
	} else {
		$namespace = '';
	}

	// Create namespaces for each view and view type in app.life
	if (empty($namespace)) {
		$return .= $root.'.children = {};';
	} else {
		$return .= $root.$namespace.' = {};';
		$return .= $root.$namespace.'.children = {};';
	}
	
	foreach ($child as $key => $value) {

		// Get behavior files
		if ($key == 'behavior' || $key == 'configuration') {

			// Iterate through files
			foreach ($value as $value2) {

				$temp = $p['apps'].$app['id'].'/'.$path.$value2;
				if (file_exists($temp)) {

					$temp = file_get_contents($temp);
					$temp2 = pathinfo($value2, PATHINFO_FILENAME);

					// Parse JSON
					if (detect($value2, 'extension') == 'json') {
						$temp3 = json_decode($temp, true);
						if ($temp3 !== NULL) {
							$return .= '
								'.str_replace('-', '_', $root.$namespace.'.'.$temp2).' = '.$temp.';
							';
						}

					// Parse JS
					} else if (detect($value2, 'extension') == 'js') {

						// Make JS file into a view method
						$return .= '
							'.str_replace('-', '_', $root.$namespace.'.'.$temp2).' = '.'function (app, view, shared) {

								// Custom behavior from app package
								'.$temp.'
								';

								// Make sure view method is resolved
								if (strpos($temp, 'view.status.resolve(') === false && strpos($temp, 'view.status.reject(') === false) {
									$return .= '
									view.status.resolve();
									';
								}

								// View method's return value
								$return .= '
								return view.status.promise();
							};
						';
						
					// Any other objects
					} else {
						$return .= $root.$namespace.'.'.$temp2.' = '.$temp.';';
						
					}

				}

			}
			
		}
		
		// Children go through the same as parents
		if ($key == 'children' and !empty($value)) {
			foreach ($value as $key2 => $value2) {
				$return .= behavior_to_js($value2, $root, $path.$key2.'/');
			}
		}
		
	}

	return $return;
}
?>