<?php
$action['status'] = 200;
$action['output'] = '';



// Package contents
$app = array_merge($app, package_map_contents($app));

// NOTE the "app" object in JS is created here

// Build the base app object for JS
$action['output'] .= '
var app = {

	// Meta info
	id: "'.$app['id'].'",
	meta: '.json_encode($app['meta']).',
	paths: '.json_encode($paths['domain']).',
	viewport: '.json_encode($app['viewport']).',

	// State handling
	state: {},
	lock: false,
	transitions: 0,

	// Code
	shared: {},
	life: {},

	// Settings
	actions: {},
	settings: {},

	memory: {},
	url: []
};
';

// Shared code for the whole app
// FLAG I'm cheating since I'm using file system and not $app['shared'] - $app should really have recursive arrays for this
if (!empty($app['shared'])) {

	// Create namespaces based on directories
	$temp = $p['apps'].$app['id'].'/'.$constants['app package']['shared'];
	foreach (rglob_dir($temp) as $value2) {
		$action['output'] .= 'app.shared.'.rtrim(str_replace('/', '.', str_replace($temp, '', $value2)), '.').' = {};';
	}

	// Fill the namespaces with shared code
	foreach ($app['shared'] as $value) {
		if (in_array(detect($value, 'extension'), array_merge($constants['app package']['file types']['configuration'], $constants['app package']['file types']['behavior']))) {
			$temp2 = implode('.', explode('/', $value, -1));
			$temp2 .= empty($temp2) ? '' : '.';
			$action['output'] .= 'app.shared.'.$temp2.pathinfo($value, PATHINFO_FILENAME).' = '.file_get_contents($temp.$value).';';
		}
	}

}

// Views and view types
if (!empty($app['views'])) {
	$action['output'] .= behavior_to_js($app['views'], 'app.life', $constants['app package']['views']);
}

// Add list of supported actions
foreach ($app['actions'] as $value) {
	$action['output'] .= 'app.actions.'.$value.' = ["'.implode('", "', $available['actions'][$value]).'"];';
}

// Custom settings
if (!empty($app['settings'])) {
	$action['output'] .= 'app.settings = '.json_encode($app['settings']).';';
}

// App's custom launch method
$temp = $p['apps'].$app['id'].'/'.$constants['app package']['launch'];
if (file_exists($temp)) {
	$temp = file_get_contents($temp);
} else {
	$temp = '';
}

// Compose launch method
$action['output'] .= '
	app.launch = function (app, shared) {

		// Support deferred objects if available
		if (typeof $ !== "undefined") {
			var status = $.Deferred();
		}

		// Custom code from app package
		'.$temp.'
		';

		// Resolution
		if (strpos($temp, 'status.resolve(') === false && strpos($temp, 'status.reject(') === false) {
			$action['output'] .= '
			// Support deferred objects if available
			if (typeof $ !== "undefined") {
				status.resolve();
			}
			';
		}

		// Return value
		$action['output'] .= '
		// Support deferred objects if available
		if (typeof $ !== "undefined") {
			return status.promise();
		}
		
	};
';



// Tools
// NOTE I need to include these after the app object is in place
// FLAG maybe I shouldn't, but I want to create tools in JS library dynamically - might move that to app initialization
if (!empty($app['tools']['internal'])) {
	foreach ($app['tools']['internal'] as $value) {
		if (in_array(detect($value, 'extension'), $constants['app package']['file types']['behavior'])) {
			$action['output'] .= '
			'.file_get_contents($p['tools'].$value).'
			';
		}
	}
}
if (!empty($app['tools']['included'])) {
	foreach ($app['tools']['included'] as $value) {
		if (in_array(detect($value, 'extension'), $constants['app package']['file types']['behavior'])) {
			$action['output'] .= '
			'.file_get_contents($p['apps'].$app['id'].'/'.$constants['app package']['tools'].$value).'
			';
		}
	}
}



// Minify when we're going to create a cache file anyway
if ($settings['cache'] > 0) {
	$action['output'] = Minifier::minify($action['output'], array('flaggedComments' => false));
}
?>