<?php

// Manipulate CSS
function manipulate_urls($string, $rootPath = '', $relativePath = '') {

	global $paths;
	global $app;

	// Internal URLs (from app package root)
	$string = preg_replace('/url\(\s*("|\')?(?:\/)([^"\')]*)("|\')?\)/', 'url("'.$rootPath.'\\2")', $string);

	// Use endpoint (special case, reconvert the relative URLs I just captured)
	// FLAG hardcoded 'use/', need to parse it from $paths
	$string = str_replace('url("'.$rootPath.'use/', 'url("'.$paths['domain']['use'].$app['id'].'/', $string);

	// Internal relative URLs (within the current path)
	$string = preg_replace('/url\(\s*("|\')?(?!\/|http)([^"\')]*)("|\')?\)/', 'url("'.$rootPath.$relativePath.'\\2")', $string);

	return $string;
}

// Returns style assets from files in app packages recursively
function styles_from_package($child, $path = '') {

	global $p;
	global $app;

	$return = '';

	// Iterate through the assets
	foreach ($child as $key => $value) {

		// Get style files
		if ($key == 'style') {
			
			// Limit selectors to wrappers
			// FLAG class names should come from some Proot config, somehow
			$temp_wrapper = '';
			$temp = array_slice(explode('/', $path, -1), 1);
			if (empty($temp)) {
				$temp_wrapper = '.app';
			} else {
				$temp_wrapper = '.app .wrapper_'.implode('_', $temp);
			}

			// Values from each file
			foreach ($value as $value2) {

				$temp = $p['apps'].$app['id'].'/'.$path.$value2;
				if (file_exists($temp)) {
					$temp = file_get_contents($temp);

					// Limit selectors
					$return .= '
						'.$temp_wrapper.' {
							'.manipulate_urls($temp, $paths['domain']['apps'].$app['id'], $path).'
						}
					';

				}

			}
			
		}
		
		// Children go through the same as parents
		if ($key == 'children' and !empty($value)) {
			foreach ($value as $key2 => $value2) {
				$return .= styles_from_package($value2, $path.$key2.'/');
			}
		}
		
	}

	return $return;
}
?>