<?php
$action['content type'] = 'html';
$action['status'] = 200;



// Prefix URL with correct paths
// FLAG duplication from web/template
function manipulate_urls ($string, $path = '') {

	global $paths;
	global $app;

	// Internal URLs (from app package root)
	$string = preg_replace('/(src|href)\s*=\s*[\"\'](?:\/)([^"\']*)[\"\']/U', '\\1'.'="'.$paths['domain']['apps'].$app['id'].'/'.'\\2"', $string);

	// Use endpoint (special case, reconvert the relative URLs I just captured)
	// FLAG hardcoded 'use/', need to parse it from $paths
	$string = str_replace('href="'.$paths['domain']['apps'].$app['id'].'/use/', 'href="'.$paths['domain']['use'].$app['id'].'/', $string);
	$string = str_replace('src="'.$paths['domain']['apps'].$app['id'].'/use/', 'src="'.$paths['domain']['use'].$app['id'].'/', $string);

	// Internal relative URLs (within the current path)
	$string = preg_replace('/(src|href)\s*=\s*[\"\'](?!\/|http|ftp|#|mailto:)([^"\']*)[\"\']/U', '\\1'.'="'.$paths['domain']['apps'].$app['id'].'/'.$path.'\\2"', $string);

	return $string;
}



// Package contents
$app = array_merge($app, package_map_contents($app));



// Compose the file path based on input (app root is default)
$action['path'] = $p['apps'].$app['id'].'/';

// Fetch structure files from views
if ($input['source'] == 'view') {
	$action['path'] .= $constants['app package']['views'];

	// Type-specific
	if (!empty($input['type'])) {
		$action['path'] .= $input['type'].'/';
	}

	// View-specific
	if (!empty($input['view'])) {
		$action['path'] .= $input['view'].'/';
	}

// Shared assets
} else if ($input['source'] == 'shared') {
	$action['path'] .= $constants['app package']['shared'];

	// Directory
	// FLAG this needs to be treated as a proper path
	if (!empty($input['type'])) {
		$action['path'] .= $input['type'].'/';
	}

	// Subdirectory
	if (!empty($input['view'])) {
		$action['path'] .= $input['view'].'/';
	}

}



// Just throw in all the view-level HTML files we have
$action['output'] = '';
$temp = glob_files($action['path'], $constants['app package']['file types']['structure']);

// Nothing to output
if (count($temp) < 1) {
	$errors[] = '404 no structure found for this '.$input['source'];

// Merge all structure files in the directory
} else {
	foreach ($temp as $value) {
		$action['output'] .= '
		'.file_get_contents($value).'
		';
	}
}

// Prefix URLs
$action['output'] = manipulate_urls($action['output'], dont_start_with($action['path'], $p['apps'].$app['id'].'/'));
?>