<?php
// App configuration
// This file extracts information of the app selected for execution
// FLAG the result format of shared code, resources, views, tools etc. is inconsistent
$app = array(
	'id' => $choices['app']
);

// Check for a manifest file
$filepath = $p['apps'].$app['id'].'/'.$constants['app package']['manifest'];
if (is_file($filepath)) {
	$file = json_decode(file_get_contents($filepath), true);
	if ($file === NULL or !is_array($file)) {
		$errors[] = '412 '.$app['id'].'\'s manifest file is malformatted';
	}
}

if (empty($errors)) {

	// Whitelist config values from manifest
	foreach ($constants['app package']['manifest content'] as $id) {
		if (isset($file[$id]) and !empty($file[$id])) {
			$app[$id] = to_array($file[$id]);
		} else {
			$app[$id] = array();
		}
	}



	// Default language
	if (empty($app['languages'])) {
		$app['languages'][] = $settings['language'];
	}

	// Default to allow all actions
	if (empty($app['actions'])) {
		$app['actions'] = array_keys($available['actions']);

	// App requested only some backend actions
	// FLAG should allow setting individual actions, not just full groups
	} else {

		// Pick out missing actions
		$missing = array();
		foreach ($app['actions'] as $id) {
			if (!array_key_exists($id, $available['actions'])) {
				$missing[] = $id;
			}
		}

		// Something was missing, print out errors
		if (!empty($missing)) {
			$errors[] = '500 this app requires '.limplode(', ', $missing, ' and ').' in the backend';
		}

	}

}
?>