<?php
// Selecting basic system variables via user-exposed parameters
$choices = array();



// Take in the basic, configured system input parameters from GET (empties filtered)
$temp = run_validations($request['body']['get'], array(
	'app' => array(
		'type' => 'string',
		'values' => $available['apps']
	),
	'action_parent' => array(
		'type' => 'string',
		'values' => array_keys($available['actions'])
	),
	'action' => array(
		'type' => 'string'
	)
));

// Validation failed
if (isset($temp['errors'])) {
	$errors = array_merge($errors, $temp['errors']);

// No errors
} else {

	// Make sure the action is available
	// FLAG run_validations could support having accepted values depend on the given values of others in schemas
	if (!in_array($temp['action'], $available['actions'][$temp['action_parent']])) {
		$errors[] = '400 only '.limplode(', ', $available['actions'][$temp['action_parent']], ' or ').' are available in '.$temp['action_parent'];

	// Everything passes
	} else {
		$choices['app'] = $temp['app'];
		$choices['action'] = array('parent' => $temp['action_parent'], 'id' => $temp['action']);
	}

}
?>