<?php
// Create a friendly error response for a user
// FLAG I'm duplicating a lot of stuff from success phases - I should aim for having a response phases that work with errors
$response = array('file output' => false);
$headers = array();
$output = array();

// Get a single status code for the response from the first error
$response['status'] = intval(substr($errors[0], 0, 3));

// Manipulate error messages for humans
if ($response['status'] == 500 && !$settings['debug']) {
	$errors = array('Something went wrong behind the scenes. Try again in a minute or contact the site administrator.');
} else {
	foreach ($errors as $key => $value) {
		$errors[$key] = ucfirst(substr($value, 4)).'.';
	}
}



// Guessing the appropriate content type from action
if (isset($action['content type']) and array_key_exists($action['content type'], $constants['content types'])) {
	$response['content type'] = $constants['content types'][$action['content type']];

// Action has full MIME type
} else if (isset($action['content type']) and preg_match($constants['patterns']['content type'], $action['content type'])) {
	$temp = array_flip($constants['content types']);
	if (array_key_exists($action['content type'], $temp)) {
		$response['content type'] = $temp[$action['content type']];
	}

// Guess based on HTTP method
} else if (isset($request['method']) and isset($constants['default content types'][$request['method']])) {
	$response['content type'] = $constants['content types'][$constants['default content types'][$request['method']]];

}

// No valid content type given
if (!isset($response['content type'])) {
	$temp = array_keys($constants['default content types']);
	$response['content type'] = $constants['default content types'][$temp[0]];
}



// Header strings
$headers[] = 'Cache-Control: no-store';
$headers[] = $settings['http version'].' '.$constants['status codes'][$response['status']];

// Content type headers, with character set for some types
$temp = $response['content type'];
if (in_array(substr($response['content type'], 0, strpos($response['content type'], '/')), array('text', 'application'))) {
	$temp .= '; charset='.$settings['character set'];
}
$headers[] = 'Content-type: '.$temp;

// CORS
if ($settings['cors']) {
	$headers[] = 'Access-Control-Allow-Origin: '.$settings['cors'];
}



// Format-specific output
$temp = array_flip($constants['content types']);
$temp = $paths['server']['errors'].$temp[$response['content type']].'.php';
if (file_exists($temp)) {
	include_once $temp;
} else {
	$output = implode(' ', $errors);
}

?>