<?php
// Validate and prioritize user input
// FLAG I should take all GET in first, then overwrite individual values with POST content so both can be used simultaneously (but I have to make sure validations handle values with numerical keys properly)
// 
// NOTE
//   - All parameters for background actions go through this
//   - Empty (excluding 0 or false) or otherwise nonsensible parameters do not result in errors, they are simply dropper and ignored.
$input = array();



// PUT content gets preference
// FLAG completely untested, no idea what this will contain
if (!empty($request['body']['put'])) {
	$input = $request['body']['put'];



// POST (supports file uploads)
} else if (!empty($request['body']['post'])) {

	// PHP gives us an acceptable array
	$input = $request['body']['post'];

	// Include any uploaded files
	if (!empty($request['files'])) {
		foreach ($request['files'] as $id => $array) {

			// Only successful uploads are accepted
			if ($array['error'] === 0) {

				// Create the file input array
				$input[$id] = array(
					'name' => $array['name'],
					'size' => $array['size'],
					'type' => $array['type'],
					'location' => $array['tmp_name']
				);

			// Just stop for errors, file uploads need to work
			} else if (in_array($array['error'], array(1, 2))) {
				$errors[] = '400 the file you are trying to upload is too big';
				break;
			} else if ($array['error'] == 3) {
				$errors[] = '500 the whole upload didn\'t come through for some reason';
				break;
			} else if ($array['error'] != 4) {
				$errors[] = '500 file upload didn\'t work for some reason';
				break;
			}

		}
	}



// I can dig the input from the midst of GET, too
} else if (!empty($request['body']['get']['input'])) {

	// Interpret input as JSON if it's valid JSON
	$input = json_decode(utf8_encode(stripslashes($request['body']['get']['input'])), true);

	// Nope, it's in a shorthand format
	if ($input === NULL) {
		$input = shorthand_decode($request['body']['get']['input']);
	}

	// Drop nonsensible values
	foreach ($input as $key => $value) {
		if (empty($value) and !is_numeric($value)) {
			unset($input[$key]);
		}
	}

}
?>