<?php
// Information about the incoming request and client
$request = array(

	// Cookies
	'cookies' => $_COOKIE,

	// What the user sent
	'files' => $_FILES,
	'body' => array(
		'get' => $_GET,
		'post' => $_POST,
		'put' => ''
	)

);

// Convert $_SERVER to something sane reliably
// FLAG a bit hacky, but works
foreach (array(

	// Where the request came to
	'server address' => 'SERVER_ADDR',
	'host' => 'HTTP_HOST',
	'port' => 'SERVER_PORT',
	'protocol' => 'SERVER_PROTOCOL',

	// How the request was sent
	'method' => 'REQUEST_METHOD',
	'time' => 'REQUEST_TIME',

	// Something about the user
	'user agent' => 'HTTP_USER_AGENT',
	'connection' => 'HTTP_CONNECTION',

	// What the user wants back
	'accept' => array(
		'content type' => 'HTTP_ACCEPT',
		'character set' => 'HTTP_ACCEPT_CHARSET',
		'encoding' => 'HTTP_ACCEPT_ENCODING',
		'language' => 'HTTP_ACCEPT_LANGUAGE'
	)

) as $key => $value) {

	// Individual value from $_SERVER
	if (is_string($value)) {
		$request[$key] = isset($_SERVER[$value]) ? strtolower($_SERVER[$value]) : '';

	// A group of values from $_SERVER
	} else if (is_array($value)) {
		$request[$key] = array();
		foreach ($value as $key2 => $value2) {
			$request[$key][$key2] = isset($_SERVER[$value2]) ? strtolower($_SERVER[$value2]) : '';
		}
	}
}



// Raw headers for debugging
if ($settings['debug']) {
	$request['raw headers'] = function_exists('getallheaders') ? getallheaders() : array();
}

// Add absolute URL
$request['url'] = substr($request['protocol'], 0, strpos($request['protocol'], '/')).'://'.$request['host'].'/'.$paths['bare']['root'];

// Attempt to retrieve PUT data
// FLAG completely untested
if ($request['method'] == 'put') {
	$request['body']['put'] = file_get_contents('php://input', 'r');
}

// Parse accept headers into something sane
// NOTE I downcase the values for internal consistency. They're invalid for output.
foreach ($request['accept'] as $id => $string) {

	// Accept headers are sorted arrays
	$request['accept'][$id] = array();

	if (!empty($string)) {

		// Split the accept header string
		// NOTE string value itself is the key in array, importance is the value for sorting
		$strings = array();
		foreach (explode(',', strtolower(str_replace(' ', '', $string))) as $value) {

			// Very specific
			if (strpos($value, ';q=')) {
				$temp = explode(';q=', $value);
				$strings[$temp[0]] = $temp[1];

			// Very generic
			} else if (strpos($value, '*/*') !== false) {
				$strings[$value] = -1;

			// Type-specific
			} else if (strpos($value, '/*') !== false) {
				$strings[substr($value, 0, strpos($value, '/*'))] = 0;
				
			// Just normal
			} else {
				$strings[$value] = 1;

			}

		}

		// Sort based on importance
		arsort($strings);

		// Output string values only
		$request['accept'][$id] = array_keys($strings);

	}
}



// Let's kill these so we don't shoot ourselves to the foot later
unset($_GET, $_POST, $_REQUEST, $_COOKIE, $_SERVER, $_FILES);

?>