<?php
// Create the meta info for the response
$response = array();

// Decide output status
if (isset($action['status']) and array_key_exists($action['status'], $constants['status codes'])) {
	$response['status'] = $action['status'];
} else {
	$response['status'] = 200;
}



// File output
if (isset($action['file output']) and in_array($action['file output'], array('redirect', 'read file'))) {
	$response['file output'] = $action['file output'];
} else {
	$response['file output'] = false;
}



// Decide the content type of the response
// FLAG no real content negotiation

// Action has something to say
if (isset($action['content type'])) {

	// Shorthand from configuration
	if (array_key_exists($action['content type'], $constants['content types'])) {
		$response['content type'] = $constants['content types'][$action['content type']];

	// Custom complete valid MIME type
	} else if (preg_match($constants['patterns']['content type'], $action['content type'])) {
		$response['content type'] = $action['content type'];

	}

// Guess from filename when outputting files
} else if ($response['file output']) {
	$temp = detect($action['output'], 'extension');
	if (array_key_exists($temp, $constants['content types'])) {
		$response['content type'] = $constants['content types'][$temp];
	}

}

// No valid content type given, use default
if (!isset($response['content type'])) {

	// Based on HTTP method
	if (isset($request['method']) and isset($constants['default content types'][$request['method']])) {
		$response['content type'] = $constants['content types'][$constants['default content types'][$request['method']]];

	// Just pick the one for GET
	} else {
		$response['content type'] = $constants['default content types']['get'];
	}

}



// Browser cache expiration
if ($response['status'] < 400 and $settings['browser cache'] > 0) {
	$integer = isset($action['browser cache']) and $action['browser cache'] > 0 ? $action['browser cache'] : 0;
	$response['browser cache'] = 60 * min($settings['browser cache'], $integer);
} else {
	$response['browser cache'] = 0;
}

?>