<?php
// Common individual settings

// NOTE
//   - Backend code expects all of these settings to be defined with some value.
//   - You should use a hack (after_settings.php) to customize these settings for your own installation.

// FLAG I want to get rid of debug mode
//   - not clear what it does
//   - bloats the source with debug mode checks
//   - hacks are available for adding instance-specific stuff
$settings = array(
	'admin email' 		=> '',

	'character set' 	=> 'utf-8',
	'http version' 		=> 'HTTP/1.1',
	'language' 			=> 'en',
	'timezone' 			=> 'UTC',

	// Responses
	'cache' 			=> 7*24*60,		// Maximum expiration time of cache files saved on the server, in minutes
	'browser cache' 	=> 12*60,		// Default and maximum time for cache expiration recommended to the browser, in minutes
	'cors' 				=> false,		// Support for cross-origin requests (either the CORS header value as string or boolean for all or nothing)
	'debug' 			=> false,		// Declare debug mode: leave output uncompressed, show full 500 error messages etc.

	// Credentials for optional database support
	'database' => array(

		// Credentials
		'username' 	=> '',
		'password' 	=> '',

		// Settings
		'type' 		=> '',			// When this is empty, no database is used
		'address' 	=> 'localhost',	// Leave this to "localhost" if you don't know better
		'database' 	=> 'proot',		// If this is non-empty, all apps will use the same database with this name instead of dedicated ones
		'prefix' 	=> 'proot'		// Prefixes table names in generic database or app-specific database names

	)

);
?>