<?php
// File system functionality



// Search for directories
function glob_dir ($path = '') {
	$temp = glob(end_with($path, '/').'*', GLOB_MARK | GLOB_ONLYDIR);
	foreach ($temp as $key => $value) {
		$temp[$key] = str_replace('\\', '/', $value);
	}
	return $temp;
}

// Search for files
function glob_files ($path = '', $filetypes = array()) {
	$result = array();
	foreach (glob(end_with($path, '/').'*'.(empty($filetypes) ? '' : '*.{'.implode(',', $filetypes).'}'), GLOB_BRACE) as $value) {
		if (!is_dir($value)) {
			$result[] = $value;
		}
	}
	return $result;
}



// Search for stuff recursively
function rglob ($path = '', $pattern = '*', $flags = 0) {
	$directoryectories = glob_dir($path);
	$files = glob(end_with($path, '/').$pattern, $flags);
	
	foreach ($directories as $path) {
		$files = array_merge($files, rglob($path, $pattern, $flags));
	}

	return $files;
}

// Search for stuff recursively
function rglob_dir ($path = '') {
	$directories = glob_dir($path);
	foreach ($directories as $path) {
		$directories = array_merge($directories, rglob_dir($path));
	}
	return $directories;
}

// Search for files recursively
function rglob_files ($path = '', $filetypes = array()) {
	$files = glob_files($path, $filetypes);
	foreach (glob_dir($path) as $child) {
		$files = array_merge($files, rglob_files($child, $filetypes));
	}
	return $files;
}

// Remove all files and directories
function rrmdir($directory) {
	if (is_dir($directory)) {
		$scan = scandir($directory);
		foreach ($scan as $value) {
			if ($value != '.' && $value != '..') {
				if (filetype($directory.'/'.$value) == 'dir') {
					rrmdir($directory.'/'.$value);
				} else {
					unlink($directory.'/'.$value);
				}
			}
		}
		reset($scan);
		rmdir($directory);
	}
}

?>