<?php
// Main paths for internals
// NOTE all paths should include a trailing slash
$paths = array(

	// Uncomment to manually define path to root
	// 'root' 			=> 'path/to/proot/',



	// Relative

	// Prefix for action's endpoints
	'use' 			=> 'use/',

	// Home is where index.php is
	'index' 		=> 'backend/',

	// Core functionality
	'helpers' 		=> 'backend/helpers/',
	'core' 			=> 'backend/core/',
	'hacks' 		=> 'backend/hacks/',
	'utilities' 	=> 'backend/utilities/',

	// Custom server-side code
	'actions' 		=> 'backend/actions/',
	'errors' 		=> 'backend/errors/',

	// Cached output
	'cache' 		=> 'cache/',

	// App code
	'apps' 			=> 'apps/',
	'tools' 		=> 'tools/'

);



// Automatically detect where we are in the file system
if (!isset($paths['root'])) {
	$paths['root'] = substr($_SERVER['SCRIPT_NAME'], 0, -(strlen($paths['index'].'index.php')));
	if (substr($paths['root'], 0, 1) == '/') {
		$paths['root'] = substr($paths['root'], 1);
	}
}

// Root-relative base path
$temp = $_SERVER['DOCUMENT_ROOT'];
if (substr($temp, -1) !== '/') {
	$temp .= '/';
}

// Generate final $paths
$paths = array('bare' => $paths);
foreach ($paths['bare'] as $id => $directory) {

	// Root path gets special treatment
	if ($id != 'root') {
		$directory = $paths['bare']['root'].$directory;
	}

	// Paths for clients
	// FLAG not all of these are really needed
	$paths['domain'][$id] = '/'.$directory;

	// Use is not a natural path, others get server paths
	if ($id != 'use') {
		$paths['server'][$id] = $temp.$directory;
	}

}

// Shortcuts for server-side code
$p = $paths['server'];
?>