<?php
// Hack table prefix support into RedBean

// Cubrid
if (class_exists('RedBean_QueryWriter_CUBRID', false)) {
	class MyCubridQueryWriter extends RedBean_QueryWriter_CUBRID {
		public function safeTable($name, $noQuotes = false) {
			$name = prefix_table_name($name);
			return parent::safeTable($name, $noQuotes);
		}
	}
}

// MySQL
if (class_exists('RedBean_QueryWriter_MySQL', false)) {
	class MyMysqlQueryWriter extends RedBean_QueryWriter_MySQL {
		public function safeTable($name, $noQuotes = false) {
			$name = prefix_table_name($name);
			return parent::safeTable($name, $noQuotes);
		}
	}
}

// Oracle
if (class_exists('RedBean_QueryWriter_Oracle', false)) {
	class MyOracleQueryWriter extends RedBean_QueryWriter_Oracle {
		public function safeTable($name, $noQuotes = false) {
			$name = prefix_table_name($name);
			return parent::safeTable($name, $noQuotes);
		}
	}
}

// Postgre
if (class_exists('RedBean_QueryWriter_PostgreSQL', false)) {
	class MyPostgreSqlQueryWriter extends RedBean_QueryWriter_PostgreSQL {
		public function safeTable($name, $noQuotes = false) {
			$name = prefix_table_name($name);
			return parent::safeTable($name, $noQuotes);
		}
	}
}

// SQLite
if (class_exists('RedBean_QueryWriter_SQLiteT', false)) {
	class MySQLiteTQueryWriter extends RedBean_QueryWriter_SQLiteT {
		public function safeTable($name, $noQuotes = false) {
			$name = prefix_table_name($name);
			return parent::safeTable($name, $noQuotes);
		}
	}
}



// Hack in table prefixing when using shared database
function hack_table_prefixing_support () {

	// Class names
	$classes = array(
		'RedBean_QueryWriter_CUBRID' => 'MyCubridQueryWriter',
		'RedBean_QueryWriter_MySQL' => 'MyMysqlQueryWriter',
		'RedBean_QueryWriter_Oracle' => 'MyOracleQueryWriter',
		'RedBean_QueryWriter_PostgreSQL' => 'MyPostgreSqlQueryWriter',
		'RedBean_QueryWriter_SQLiteT' => 'MySQLiteTQueryWriter'
	);

	// Override RedBean's behavior
	$class = $classes[get_class(R::$writer)];
	$writer = new $class(R::$adapter);
	R::configureFacadeWithToolbox(new RedBean_ToolBox(R::$redbean, R::$adapter, $writer));
}
?>