<?php
// Prepare cache folders into file system

// We need access to cache directory
if (is_dir($p['cache'])) {

	// Can write to directory
	if (is_writable($p['cache'])) {

		// Cache files exist now
		$dev['status'] = true;
		$dev['message'] = 'Your cache directories should generate just fine.';

	// Couldn't write to directory, no can do
	} else {
		$dev['status'] = false;
		$dev['message'] = 'I can\'t write to the cache directory. I\'m seeing I have '.substr(octdec(fileperms($p['cache'])), -3).' level privileges, but I need something higher. Use chmod, dude.';
	}

// The cache directory doesn't even exist
} else {

	$dev['status'] = false;

	// Try to create the directory for the user, but still warn
	mkdir($p['cache'], 0777);
	clearstatcache();

	// Check if we actually got it done
	if (is_dir($p['cache'])) {

		// Check that we can write to it now
		if (is_writable($p['cache'])) {
			$dev['message'] = 'The whole cache directory was missing, so I created it.';
		} else {
			$dev['message'] = 'The whole cache directory was missing. I created it, but I still can\'t write to it. You should make sure that I have the write access rights to the cache directory.';
		}

	// Can't even create the cache directory
	} else {
		$dev['message'] = 'You\'re missing the whole cache directory. I tried to create it, but I couldn\'t even do that. Make sure that you\'ve granted write access rights to the cache directory.';
	}
}
?>