<?php
foreach (array($p['hacks'].'before_available.php', $p['core'].'available.php', $p['hacks'].'after_available.php') as $value) {
	if (file_exists($value)) {
		include_once $value;
	}
}

// Make sure all backend actions have all their dependencies available
$dev['content'] = array();
$dev['status'] = 0;
$temp_all = 0;

// Iterate through all actions
foreach ($available['actions'] as $key => $value) {
	foreach ($value as $value2) {
		$dev['status']++;
		$temp_all++;

		// Include action configuration
		$temp = $p['actions'].$key.'/'.$value2.'/configuration.php';
		if (file_exists($temp)) {

			// Mock up an $action for the config
			$action = array(
				'id' => $value2
			);
			include_once $temp;

			// Get the dependencies
			if (isset($action['dependencies'])) {

				foreach ($action['dependencies'] as $key3 => $value3) {

					// Sibling action missing
					if ((is_int($key3) and is_string($value3)) and !in_array($value3, $available['actions'][$key])) {
						$dev['content'][$key][$value2][] = $value3;
						$dev['status']--;


					// Action from another pack missing
					} else if ((is_string($key3) and is_string($value3)) and (!isset($available['actions'][$key3]) or !in_array($value3, $available['actions'][$key3]))) {
						$dev['content'][$key][$value2][] = $key3.': '.$value3;
						$dev['status']--;

					// Multiple actions from another pack missing
					} else if (is_string($key3) and is_array($value3)) {
						foreach ($value3 as $value4) {
							if (!isset($available['actions'][$key3]) or !in_array($value4, $available['actions'][$key3])) {
								$dev['content'][$key][$value2][] = $key3.': '.$value4;
								$dev['status']--;
							}
						}

					}

				}

			}
		}
	}
}

if (empty($dev['content'])) {
	unset($dev['content']);
}

if ($dev['status'] == $temp_all) {
	$dev['status'] = true;
	$dev['message'] = 'All backend actions have their dependencies taken care of. Nice.';
} else {
	$dev['status'] = $temp_all - $dev['status'];
	$dev['message'] = 'Some dependencies need to be added for '.limplode(', ', array_keys($dev['content']), ' and ').' actions to work correctly.';
}

$dev['message'] .= ' This tool might display some errors, but it\'s fine if they\'re all in a "actions/*/configuration.php"';

?>