<?php
// Make sure certain directories exist and are writable
$dev['message'] = array();

// Directories should exist
$temp = array();
foreach ($p as $key => $value) {
	if (!is_dir($value)) {
		$temp[] = $key;
	}
}
if (!empty($temp)) {
	$dev['message'][] = 'I\'m not finding the directories '.limplode(', ', $temp, ' and ').' at all. You\'re missing important stuff.';
}

// Some dirs need to be writable
$temp = array();
foreach (array('apps', 'cache') as $value) {
	if (!is_writable($p[$value])) {
		$temp[] = $value;
	}
}
if (!empty($temp)) {
	$dev['message'][] = 'I can\'t write to '.limplode(', ', $temp, ' or ').' at all. Proot won\'t work properly in all situations.';
}

// Core server code should be there
$temp = array();
foreach (array('helpers', 'core') as $value) {
	$foo = glob_files($p[$value], array('php'));
	if (empty($foo)) {
		$temp[] = $value;
	}
}
if (!empty($temp)) {
	$dev['message'][] = 'There are no scripts in '.limplode(', ', $temp, ' or ').'. At least some core server code is missing, so something is seriously wrong.';
}



// We need proper access rights to cache directory
if (empty($dev['message'])) {
	$dev['status'] = true;
	$dev['message'] = 'All the necessary directories exist and seem to have their access privileges in order.';
} else {
	$dev['status'] = false;
}
?>