<?php
// Make sure that there are no conflicts between endpoints, app IDs and natural directory names
require_once $p['core'].'constants.php';

// List forbidden names for apps
$temp = array(
	'apps' => glob_dir($p['apps']),
	'endpoints' => array($paths['bare']['use']),
	'directories' => glob_dir($p['root'])
);
foreach ($temp as $key => $value) {
	foreach ($value as $key2 => $value2) {
		$temp[$key][$key2] = basename($value2);
	}
}

// Content will include any and all clashes
$dev['content'] = array('apps' => array(), 'endpoints' => array());

// Find clashing app names
foreach ($temp['apps'] as $value) {
	if (in_array($value, array_merge($temp['endpoints'], $temp['directories'])) or !preg_match($constants['patterns']['safename'], $value)) {
		$dev['content']['apps'][] = $value;
	}
}

// Find clashing endpoints
foreach ($temp['endpoints'] as $value) {
	if (in_array($value, $temp['directories'])) {
		$dev['content']['endpoints'][] = $value;
	}
}



// Success report
if (empty($dev['content']['apps']) and empty($dev['content']['endpoints'])) {
	$dev['status'] = true;
	$dev['message'] = 'I couldn\'t find any clashes in directory names, app IDs and endpoints.';
	unset($dev['content']);

// Clashes :(
} else {
	$dev['status'] = count($dev['content']['apps']) + count($dev['content']['endpoints']);
	$dev['message'] = 'Paths will not work correctly.';

	// Conflicts in app names
	if (!empty($dev['content']['apps'])) {
		$dev['message'] .= ' Some apps ('.(limplode(', ', $dev['content']['apps'], ' and ')).') have IDs that conflict with existing paths or endpoints or contain special characters. It\'s going to make life easier for all of us if you just give these apps new IDs.';
	}

	// Conflicts in endpoints vs .natural paths
	if (!empty($dev['content']['endpoints'])) {
		$dev['message'] .= ' You have directories ('.(limplode(', ', $dev['content']['endpoints'], ' and ')).') with names that are also used in Proot\'s user-friendly URLs. The easiest way to have Proot working is to rename or (re)move these directories. You can also choose other names for your endpoints, if you know what you\'re doing.';
	}

}

?>