<?php
// Root of all problems
error_reporting(E_ALL|E_STRICT);
ini_set('display_errors', '1');
date_default_timezone_set('UTC');

// Get my bearings
require 'paths.php';

// Core helpers for server-side code
foreach (glob($p['helpers'].'*.php') as $value) {
	require $value;
}

// Supported tools
$devs = array();
foreach (glob('dev/*.php') as $value) {
	$devs[] = pathinfo($value, PATHINFO_FILENAME);
}



// Current tool
if (isset($_GET['id']) and in_array($_GET['id'], $devs)) {
	$dev = array('name' => $_GET['id']);
}




// Output something kewl for the user
$output = '';

// Report status if something was done
if (isset($dev)) {

	// Run tool
	include_once 'dev/'.$dev['name'].'.php';

	// Output result
	if (is_string($dev['status']) or is_int($dev['status'])) {
		$temp = trim($dev['status']);
	} else {
		$temp = $dev['status'] ? 'success' : 'fail';
	}
	
	$output .= '
	<h1>'.$dev['name'].' '.$temp.'</h1>
	'.($dev['message'] ? '<p>'.(is_array($dev['message']) ? implode(' ', $dev['message']): $dev['message']).'</p>' : '').'
	<p><a href=".">Ok, then</a></p>
	'.((isset($dev['content']) and !empty($dev['content'])) ? '<pre>'.print_r($dev['content'], true).'</pre>' : '').'
	';


}



// Print an HTML page
echo '
<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8">
		<style type="text/css">
			body {font-family: sans-serif; padding: 2em 5%; background: #f3f2f2; color: #212626;}
			a {color: #23b0bd; text-decoration: none;} a:hover {text-decoration: underline;}
		</style>
	</head>
	<body>

		'.$output.'

		<h3>Dev tools</h3>
		<ul>
		';

		foreach ($devs as $value) {
			echo '<li><a href="?id='.$value.'">'.$value.'</a></li>';
		}

		echo '
		<ul>

	</body>
	</html>
';
?>