<?php
// Root of all problems
error_reporting(E_ALL|E_STRICT);
ini_set('display_errors', '1');
date_default_timezone_set('UTC');

// Get my bearings
require '../backend/paths.php';
require 'assets/markdown.php';

// Core helpers for server-side code
foreach (glob('../backend/helpers/*.php') as $value) {
	require $value;
}



// Availeble guide categories
$guides = array();
foreach (glob_dir('guides/') as $value) {
	$guides[basename($value)] = array();

	// Guides
	foreach (glob_files($value, array('md', 'txt', 'html', 'php')) as $value2) {
		$guides[basename($value)][pathinfo($value2, PATHINFO_FILENAME)] = $value2;
	}
	ksort($guides[basename($value)]);

}
ksort($guides);

// Order categories
$temp = array('proot', 'tutorials', 'cheatsheets', 'apps', 'actions', 'backend');
$categoryorder = array();
foreach ($temp as $value) {
	if (array_key_exists($value, $guides)) {
		$categoryorder[] = $value;
	}
}

// Current guide
if (isset($_GET['category']) and array_key_exists($_GET['category'], $guides)) {
	$category = $_GET['category'];
	
	// Valid ID
	if (isset($_GET['id']) and array_key_exists($_GET['id'], $guides[$_GET['category']])) {
		$guide = $_GET['id'];
		
	// Category default
	} else {
		$temp = array_keys($guides[$category]);
		$guide = $temp[0];
	}

// Fall back to readme
} else {
	$category = $categoryorder[0];
	$temp = array_keys($guides[$category]);
	$guide = $temp[0];
	unset($temp);
}
$file = $guides[$category][$guide];



// Output generation

// Create human-readable titles from filenames
function namify ($string) {
	return str_ireplace(array(
		'-',
		'_',
		' and ',
		'+',
		'url',
		'jquery',
		'js ',
	), array(
		' ',
		' ',
		' &amp; ',
		' &amp; ',
		'URL',
		'jQuery',
		'JS ',
	), ucfirst($string));
}

// Print a document
include_once 'template.php';
?>