<?php
header('Cache-Control: no-store');
header('Content-type: text/html; charset=utf-8');

echo '
<!DOCTYPE html>
<html lang="en">
	<head>

		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
		<style type="text/css">@-ms-viewport{width: device-width;}</style>

		<title>Proot guides</title>
		<meta name="author" content="Eiskis">
		<meta name="application-name" content="Proot guides">
		
		<link rel="shortcut icon" href="assets/favicon.ico" type="image/x-icon">
		<link rel="stylesheet" href="assets/layers.css" media="screen">
		<link rel="stylesheet" href="assets/layers_responsive.css" media="screen">
		<link rel="stylesheet" href="assets/prism.css" media="screen">
		<link rel="stylesheet" href="assets/guides.css" media="screen">

	</head>
	<body class="language-javascript '.$category.' '.$category.'_'.$guide.'">



		<div class="dark" id="menu">

			<div class="buffer first">
				<div class="contentarea">
					<ol class="plain push-left block reset">
					';

					// List all categories
					foreach ($categoryorder as $value) {
						echo '<li class="reset'.($value == $category ? ' selected': '').'"><a href="?category='.$value.'">'.namify($value).'</a></li>';
					}

					echo '
					</ol>

					<ul class="plain push-right block reset">
						<li><a href="http://eiskis.net/proot/">Proot home</a></li>
					</ul>

					<div class="clear"></div>
				</div>
			</div>

			<div class="buffer second">
				<div class="contentarea">
				
					<ol class="plain push-left block reset">
					';

					// List all guides in the category
					foreach ($guides[$category] as $key => $value) {
						echo '<li class="reset'.($key == $guide ? ' selected': '').'"><a href="?category='.$category.'&amp;id='.$key.'">'.namify($key).'</a></li>';
					}

					echo '
					</ol>

					<select class="hidden" onchange="window.open(this.options[this.selectedIndex].value,\'_top\')">
					';

					// Alternative dropdown menu
					foreach ($categoryorder as $value) {
						echo '<optgroup label="'.namify($value).'">';
						foreach ($guides[$value] as $key2 => $value2) {
							echo '<option '.(($value == $category and $key2 == $guide) ? ' selected="selected"': '').'value="?category='.$value.'&amp;id='.$key2.'">'.namify($key2).'</option>';
						}
						echo '</optgroup>';
					}

					echo '
					</select>

					<div class="clear"></div>
				</div>
			</div>

		</div>



		<div class="buffer" id="content">
			<div class="contentarea">
				';

				// Include guide contents
				$temp = detect($file, 'extension');
				switch ($temp) {
					case 'txt':
					case 'md':
						echo Markdown(file_get_contents($file));
						break;
					case 'php':
						include_once $file;
						echo $output;
						break;
					default:
						echo file_get_contents($file);
						break;
				}

				echo '
				<div class="clear"></div>
			</div>
		</div>



		<div class="dark buffer'.(($category == 'proot' and $guide == 'about') ? ' hidden' : '').'" id="footer">
			<div class="contentarea">

				<div class="column six">
					<table>

						<tr>
							<td class="third">Proot home</td>
							<td><a href="http://eiskis.net/proot/" target="_blank">eiskis.net/proot/</a></td>
						</tr>

						<tr>
							<td class="third">Documentation &amp; guides</td>
							<td><a href="http://eiskis.net/proot/guides/" target="_blank">eiskis.net/proot/guides/</a></td>
						</tr>
						<tr>
							<td class="third">Download</td>
							<td><a href="https://bitbucket.org/Eiskis/proot/get/default.zip" target="_blank">Latest version from Bitbucket</a></td>
						</tr>
						<tr>
							<td class="third">Licensed under</td>
							<td><a href="../lgpl.txt" target="_blank">GNU Lesser General Public License</a></td>
						</tr>

					</table>
				</div>

				<div class="column six last">
					<table>

						<tr>
							<td class="third">Development @ Bitbucket</td>
							<td>
								<ul class="plain close">
									<li><a href="https://bitbucket.org/Eiskis/proot/" target="_blank">Project overview</a></li>
									<li><a href="https://bitbucket.org/Eiskis/proot/src" target="_blank">Source code</a></li>
									<li class="last"><a href="https://bitbucket.org/Eiskis/proot/issues?status=new&amp;status=open" target="_blank">Issue management</a></li>
								</ul>
							</td>
						</tr>
						<tr>
							<td class="third">By Jerry Jäppinen</td>
							<td>
								<ul class="plain close">
									<li><a href="https://twitter.com/Eiskis" target="_blank">@Eiskis</a></li>
									<li><a href="http://eiskis.net/" target="_blank">eiskis.net</a></li>
									<li><a href="mailto:eiskis@gmail.com" target="_blank">eiskis@gmail.com</a></li>
									<li class="last"><a href="tel:+358407188776">+358 40 7188776</a></li>
								</ul>
								<div class="clear"></div>
							</td>
						</tr>

					</table>
				</div>

				<div class="clear"></div>
			</div>
		</div>



		<script src="assets/prism.js"></script>
		<script src="assets/respond.min.js"></script>

	</body>
</html>
';
?>