{

	links: function (container) {

		// Back navigation from overlay click
		container.on('click', '.overlay', function () {
			p.state.to.previous();
		});

		// Open and close sections with trigger links
		container.on('click', '.section .trigger a', function (event) {
			event.preventDefault();
			$(this).parents('.section').children('.container:first').slideToggle(125);
		});

		// Handle links globally
		container.on('click', 'a', function (event) {
			var link = $(this);
			var target = link.attr('href');

			// External links
			if (p.text.matches(target, 'url')) {
				link.attr('target', '_blank');

			// E-mail addresses
			} else if (p.text.matches(target, 'email')) {
				link.attr('target', '_blank');
				link.attr('href', 'mailto:' + target);

			// Prevent other links from doing bad things
			} else {
				event.preventDefault();

				// Internal navigation link found
				target = bl.trim.empties(target.split('/'));
				if (!bl.is.empty(target)) {
					var views = p.views.map();

					// Pick view ID parameters from link URL
					var view = {
						type: target[0],
						view: target[1],
						wrapper: '.wrapper_' + target[0],
						content: target[2]
					};

					// Use article view names in URL
					var url;
					if (bl.has.value(target[1], p.views.map().article)) {
						url = target[1];
					}

					// Hey, let's assume it's not shit
					p.state.to.view(view, url);

				}

			}

		});

	}
	
}