
// Iterate through each namespaces in Baseline
var namespaces = bl.list.keys(bl);
var items = [];
for (var i = 0; i < namespaces.length; i++) {
	var namespaceName = namespaces[i];
	var namespace = bl[namespaceName];

	// Fetch template
	var template = view.dom.namespace.clone();

	// Show keys or type of namespace
	var title = namespaceName;
	if (bl.is.func(namespace)) {
		title += '()';
	}

	// Create description if possible
	var description = '';
	if (bl.is.hash(namespace) && !bl.is.empty(namespace)) {

		description = [];
		var namespaceItems = bl.list.keys(namespace);

		// Add each namespace item into the description
		for (var j = 0; j < namespaceItems.length; j++) {
			var namespaceItem = namespaceItems[j];
			var baselineItem = namespace[namespaceItem];

			// Functions get brackets
			if (bl.is.func(baselineItem)) {
				description.push(namespaceItem + '()');

			// Print out single level of subitems from hashes
			} else if(bl.is.hash(baselineItem)) {
				for (var subItem in baselineItem) {
					description.push(namespaceItem + '.' + subItem + (bl.is.func(baselineItem[subItem]) ? '()' : ''));
				}

			} else {
				description.push(namespaceItem);
			}

		}

	}

	// Populate template
	var link = $('h4 > a', template);
	link.text(title);
	if (bl.is.empty(namespace) || bl.is.func(namespace)) {
		link.contents().unwrap();
	}

	if (!bl.is.empty(description)) {
		$('.description', template).populate(description);
	} else {
		$('.description', template).remove();
	}

	items.push(template.outerHtml());
}

// Insert new content
view.dom.content.append(items.join("\n\n"));
