// Helper functionality for dealing with webfont services
// Jerry Jäppinen
// eiskis@gmail.com
// http://eiskis.net/
// WTFPL'd

/*
 * DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 * Version 2, December 2004
 *
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 * DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 * TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 * 0. You just DO WHAT THE FUCK YOU WANT TO.
 */

// Load web fonts from external services
(function(window, undefined ) {

	var webfonts = {
		
		load: function (definition) {

			// Different providers require different font definitions, so let's do some normalization
			var definitions = {
				google: function (definition) {
					var result = {
						families: []
					};

					// Accept a single family as shorthand
					if (typeof definition === 'string') {
						var temp = {};
						temp[definition] = [];
						definition = temp;
					}

					// Normalize families
					for (var key in definition) {
						result.families.push(key + (definition[key].length ? ':' + definition[key].join(',') : ''));
					}
					
					return result;
				},
				ascender: function (definition) {
					return definition;
				},
				typekit: function (definition) {
					return {
						'id': definition
					};
				},
				fontdeck: function (definition) {
					return {
						'id': definition
					};
				},
				monotype: function (definition) {
					return {
						'projectId': definition
					};
				}
			};
			var providers = Object.keys(definitions);

			WebFontConfig = {};

			// Construct font config from app config
			for (var i = 0; i < providers.length; i++) {
				var provider = providers[i];
				if (definition[provider]) {
					WebFontConfig[provider] = definitions[provider](definition[provider]);
				}
			}

			// Call Google's magic
			var wf = document.createElement('script');
			wf.src = ('https:' == document.location.protocol ? 'https' : 'http') + '://ajax.googleapis.com/ajax/libs/webfont/1/webfont.js';
			wf.type = 'text/javascript';
			wf.async = 'true';
			var s = document.getElementsByTagName('script')[0];
			s.parentNode.insertBefore(wf, s);
			
		}

	};

	window.webfonts = webfonts;

})(window);
