
// jQuery-shorthands
;(function(jQuery){
	var $ = jQuery;



	// View handling
	$.fn.fetch = function (type, view, content) {
		return p.views.life.fetch(this, type, view, content);
	};
	$.fn.create = function (type, view, content) {
		return p.views.life.create(this, type, view, content);
	};
	$.fn.dispose = function (content) {
		return p.views.life.dispose(this, content);
	};



	// Lifetime methods
	$.fn.prepare = function (content) {
		return p.views.life.run(this, 'prepare', 'default', content);
	};
	$.fn.render = function (content) {
		return p.views.life.run(this, 'render', 'default', content);
	};
	$.fn.update = function (content) {
		return p.views.life.run(this, 'update', 'default', content);
	};
	$.fn.stash = function (content) {
		return p.views.life.run(this, 'stash', 'reverse', content);
	};
	$.fn.revive = function (content) {
		return p.views.life.run(this, 'revive', 'default', content);
	};
	$.fn.unrender = function (content) {
		return p.views.life.run(this, 'unrender', 'reverse', content);
	};
	$.fn.kill = function (content) {
		return p.views.life.run(this, 'kill', 'reverse', content);
	};



	// Values of DOM elements
	$.fn.detect = function (element) {
		return p.dom.detect($(this[0]));
	};
	$.fn.extract = function (element) {
		return p.dom.extract($(this[0]));
	};
	$.fn.populate = function (content, content2, content3) {
		return p.dom.populate($(this), content, content2, content3);
	};
	$.fn.fill = function (content) {
		return p.dom.fill($(this), content);
	};



	// Manipulating state of DOM objects
	$.fn.disable = function () {
		var self = this;
		self.each(function () {
			p.dom.to.disabled($(this));
		});
		return self;
	};
	$.fn.enable = function () {
		var self = this;
		self.each(function () {
			p.dom.to.enabled($(this));
		});
		return self;
	};

	// Get info on state
	$.fn.disabled = function () {
		var element = $(this[0]);
		return p.dom.is.disabled(element);
	};
	$.fn.enabled = function () {
		var element = $(this[0]);
		return p.dom.is.enabled(element);
	};
	// NOTE this is jQuery's implementation, we're assuming that's what you'd want to use with jQuery
	$.fn.hidden = function () {
		return this.is(':hidden');
	};
	$.fn.visible = function () {
		return !this.hidden();
	};



	// Simple helpers
	$.fn.isEmpty = function () {
		return bl.is.empty(p.dom.extract(this));
	};
	$.fn.outerHtml = function () {
		return p.html.raw(this[0]);
	};

})(jQuery);
