//Slides
;(function($) {

  //Initialize Slides within the selected DOM object
  $.fn.slides = function () {

    //Initialize each slider row
    var row = this;
    var count = $('.container', row).length;

    //Only show first container by default
    $(row).css({'width': '100%', 'position': 'relative', 'overflow-x': 'hidden'});
    $('.container', row).wrap('<div class="wrap" />');
    $('.wrap', row).css({'width': '100%', 'float': 'left', 'clear': 'none', 'position': 'relative', 'left': '100%'});
    $('.wrap:first', row).css({'left': '0'}).show().addClass('active');

    //Navigation links
    $('.container a.next', row).click(function() {
      var container = $(this).parents('.wrap').next('.wrap').children('.container');
      if (container.length > 0) {
        $(container).view();
      }
    });

    $('.container a.previous', row).click(function() {
      var container = $(this).parents('.wrap').prev('.wrap').children('.container');
      if (container.length > 0) {
        $(container).view();
      }
    });

    return row;

  };

  //Slide the selected container into view
  $.fn.view = function () {

    var container = $(this).parent('.wrap');
    var row = $(container).parents('.row');
    var active = $('.active', row);
    var containerIndex = $(container).index();
    var activeIndex = $(active).index();

    //Don't accept switching views in queue
    if ($('.wrap.active', row).length == 1 && containerIndex != activeIndex) {

      var start, end;

      // Move container from the left
      if (containerIndex < activeIndex) {
        start = '-100%';
        end = '100%';

      // Move container from the right
      } else {
        start = '100%';
        end = '-100%';
        
      }

      $(container).css({'left': start}).addClass('active').show();
      
      // Move selected container
      $(container).animate({
        'left': '0%'
      }, 300);


      // Move active container
      $(active).animate({
        'left': end
      }, 300, function () {
        $(active).removeClass('active');
      });

      // Also animate footer background
      $('.footer .row').animate({
        'left': - 100 - $(container).parent('.wrap').index() * 100 + 'px'
      });

    }

    return container;

  };

})(jQuery);
