/*
 * The Proot library
 * For docs & other info, check out
 * http://eiskis.net/proot/
 * https://bitbucket.org/Eiskis/proot/
 *
 * By Jerry Jäppinen
 * Released under the GNU Lesser General Public License
 * eiskis@gmail.com
 * http://eiskis.net/
 * @Eiskis
 */

// This is a little pointless -_-
(function(window, undefined ) {

	var p = {

		// Internal tools
		'_': {

			// Get current classes
			// FLAG this is retarded, jQuery >_<
			getClasses: function (element) {
				var classes = element.attr('class');
				if (classes) {
					classes = classes.split(' ');
				} else {
					classes = [];
				}
				return classes;
			},


			// Return getter-setter methods for a global object
			getterSetter: function (object, parameter) {
				return (function () {
					var obj = object;
					var par = parameter;
					return {
						get: function () {
							var value = bl.get.value(window[obj][par]);
							return bl.is.set(arguments[0]) ? value[arguments[0]] : value;
						},
						set: function () {
							if (bl.is.set(arguments[1])) {
								return window[obj][par][arguments[0]] = arguments[1];
							} else {
								return undefined;
							}
						},

						// FLAG replace these with set()
						add: function () {
							return window[obj][par][arguments[0]] = arguments[1];
						},
						update: function () {
							return window[obj][par][arguments[0]] = arguments[1];
						}

					};
				})();
			}

		},

		// Values used throughout the library
		conf: {

			// Default polling interval used in internal functions
			pollInterval: 10,

			// Predefined formats as regular expressions
			formats: {
				email: /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/,
				ip: /^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\.([01]?\\d\\d?|2[0-4]\\d|25[0-5])$/,
				url: /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
			},

			// Backend-related
			server: {

				// Where the HTML for apps and views are fetched
				templateSource: {
					parent: 'web',
					action: 'template'
				}

			},

			// DOM handling
			dom: {
				
				// Canonical DOM element types and categories
				types: {
					'app': 'html',
					'body': 'body',

					'image': 'img',
					'link': 'a',

					'checkbox': 'input[type="checkbox"]',
					'radio': 'input[type="radio"]',
					'file': 'input[type="file"]',
					'password': 'input[type="password"]',
					'textfield': 'input[type="text"], input[type="email"], input[type="url"], input[type="search"], input[type="tel"], textarea',
					'button': 'input[type="submit"], input[type="reset"], input[type="button"], button',

					'list': 'select, optgroup, ul, ol, dl',
					'listItem': 'option, li, dt, dd',

					'row': 'tr',
					'cell': 'th, td',

					'heading': 'h1, h2, h3, h4, h5, h6',		// FLAG include captions & labels?
					'container': 'header, hgroup, footer, section, summary, article, aside, menu, nav, form, fieldset, table, thead, tbody, tfooter, div, p, blockquote, pre',
					'inline': 'em, strong, small, sub, sup, var, span, code, dfn, del, ins, kbd, q, mark, label'
				}

			},

			// Class names used in view handling
			views: {
				classNames: {
					app: 'app',
					wrapper: 'wrapper',
					view: 'view',
					status: 'status'
				},
				lifetime: [
					'prepare',
					'render',
					'update',
					'stash',
					'revive',
					'unrender',
					'kill'
				]
			},

			// Contents of state
			state: ['type', 'view', 'wrapper', 'content']

		}

	};

	window.p = p;
	window.proot = p;

})(window);
