
// Fetch info of the currently running app
p.app = {

	get: function () {
		return bl.get.value(window.app);
	},

	// Runtime storage
	memory: p._.getterSetter('app', 'memory'),
	settings: p._.getterSetter('app', 'settings'),

	// Launch an app into a container object (i.e. <body>)
	launch: function (container) {

		// Mark wrapper & container
		container = $(container);
		window.app.container = container;
		window.app.wrapper = container.parent();

		var app = p.app.get();

		// Enforce class names
		// FLAG do I need two classnames?
		app.wrapper.addClass(p.conf.views.classNames.app);
		app.wrapper.addClass(p.conf.views.classNames.app + '_' + app.id);

		// Enforce one ID, for app wrapper
		app.wrapper.attr('id', p.conf.views.classNames.app + '_' + app.id);

		// History states
		if (p.state && p.state.supported()) {
			p.state.initialize();
		}

		// Run app's main behavior
		if (bl.is.func(app.launch)) {
			app.launch(app, bl.get.value(app.shared));
		}

	}

};
