
// Simple dev helpers & tools
p.dev = {

	// Returns the type and rough value of the target object
	wat: function (value, logging) {

		var length = 72;
		var result = bl.get.type(value) + ': `';
		var string = bl.trim.whitespace(bl.to.str(value));

		// Hash contents
		if (bl.is.hash(value)) {
			result += bl.to.str(bl.list.keys(value));

		// Others
		} else {
			result += string.substr(0, length) + (bl.get.length(string) > length ? ' ... ' : '');
		}

		result +=  '`';

		if (logging) {
			p.dev.log(result);
		}
		return result;
	},

	// Console log
	log: function (value) {
		if (console && console.log) {
			console.log(value);
		}
		return value;
	},



	// Highlights DOM elements
	dom: function (color) {

		if (!color) {
			color = 'red';
		}

		var cssNode = document.createElement('style');
		cssNode.type = 'text/css';
		cssNode.rel = 'stylesheet';
		cssNode.media = 'screen';
		cssNode.title = 'dynamicSheet';
		document.getElementsByTagName('head')[0].appendChild(cssNode);

		for (var i = document.styleSheets.length-1; i > 0; i--) {
			document.styleSheets[i].addRule('div, section, header, footer, p, ul, ol, li, dl, dt, dd, a, table, th, td', 'box-shadow: 0 0 1px 1px ' + color);
		}

		return 'Let there be light!';

	},

	// Do some bullshit operation for a while
	deferred: function () {
		var dfd = $.Deferred();

		var interval = 100;
		var count = 4;

		p.dev.log('-- start --');

		// Print something in even intervals
		for (var i = 1; i <= count; i++) {
			(function () {
				var j = i;
				var period = j*interval;
				p.control.wait(period).then(function () {
					p.dev.log('Test! ' + j);
				});
			})();
		}

		p.control.wait(interval*(count+1)).then(function () {
			p.dev.log('-- end --');
			dfd.resolve();
		});

		return dfd.promise();
	}

};
