
p.normalize = {

	// Run all normalization functions
	all: function () {
		p.normalize.console();
		p.normalize.objectKeys();
	},

	// Make sure the browser has the console object
	console: function () {
		if (!window.console) {
			window.console = {
				log: function () {return true;}
			};
		} else if (!window.console.log) {
			window.console.log = function () {return true;};
		}
	},

	// Object keys
	objectKeys: function () {
		Object.keys = Object.keys || (function () {

			var hasOwnProperty = Object.prototype.hasOwnProperty,
				hasDontEnumBug = !{toString:null}.propertyIsEnumerable("toString"),
				DontEnums = [
					'toString',
					'toLocaleString',
					'valueOf',
					'hasOwnProperty',
					'isPrototypeOf',
					'propertyIsEnumerable',
					'constructor'
				],
				DontEnumsLength = DontEnums.length;
		
			return function (o) {
				if (typeof o != "object" && typeof o != "function" || o === null)
					throw new TypeError("Object.keys called on a non-object");
		
				var result = [];
				for (var name in o) {
					if (hasOwnProperty.call(o, name))
						result.push(name);
				}
		
				if (hasDontEnumBug) {
					for (var i = 0; i < DontEnumsLength; i++) {
						if (hasOwnProperty.call(o, DontEnums[i]))
							result.push(DontEnums[i]);
					}
				}
		
				return result;
			};

		})();
	}

};
