
// Location info
// FLAG minor repetition on treating the absolute parameter
p.paths = {

	get: {

		// Root of absolute URL
		host: function (trailingSlash) {
			if (!bl.is.set(trailingSlash)) {
				trailingSlash = true;
			}
			var result = p.paths.trim(document.location.origin);
			return (trailingSlash ? result : result.substring(0, result.length-1) );
		},

		// Root of installation
		root: function (absolute) {
			return (absolute ? p.paths.get.host(false) : '') + p.app.get().paths.root;
		},

		// Current protocol
		protocol: function (shitAtTheEnd) {
			var base = document.location.protocol;
			return base.substring(0, base.indexOf(':')) + (shitAtTheEnd ? '://' : '');
		},



		// Base endpoints

		// This web app
		app: function (absolute) {
			return p.paths.get.root(absolute) + p.paths.trim(p.app.get().id);
		},

		// The contents of this app package
		// FLAG hardcoded app address, PHP should bring this to me
		appPackage: function (absolute) {
			var app = p.app.get();
			return (absolute ? p.paths.get.host(false) : '') + app.paths.apps + p.paths.trim(app.id);
		},

		// Use endpoint (for action endpoints)
		use: function (absolute) {
			var app = p.app.get();
			return (absolute ? p.paths.get.host(false) : '') + app.paths.use + p.paths.trim(app.id);
		},

		// Everything
		current: function (absolute) {
			if (absolute) {
				return p.paths.trim(document.location.href);
			} else {
				return p.paths.trim(document.location.pathname);
			}
		},

		// Path within currently running app
		local: function () {
			return p.paths.get.current().substring(p.paths.get.app().length);
		}

	},

	// FLAG move this to p.app, replace app.url with this
	parameters: function () {
		return bl.remove.empties(p.paths.get.local().split('/'));
	},



	// Always end with slash
	// FLAG "." is usually a part of string value in Proot, and one we'd like to add trailing slash after
	trim: function (path, force) {

		// Add slash when appropriate
		if (force || (
				path.length &&
				path[path.length-1] != '/' &&
				!bl.has.value(['?', '&', '.'], bl.find.last.value(path.split('/')))
			)) {

			path += '/';
		}

		return path;
	}

};
