
// Generic & basic text manipulation
p.text = {

	// Check out if a string matches a specific format
	matches: function (input, formats) {

		// Make sure we have valid formats to compare to
		formats = bl.to.array(formats);
		formats = bl.list.shared.values(formats, bl.list.keys(p.conf.formats));

		// Input passes unless a format restricts it
		var result = true;

		// Go through all the regexps that need to pass
		if (!bl.is.empty(formats)) {
			for (var i = 0; i < formats.length; i++) {
				var format = formats[i];

				// We can only test with strings
				if (!bl.to.str(input).match(p.conf.formats[format])) {
					result = false;
					break;
				}

			}
		}
		
		return result;
	}

};
