
// Convert values to a specified string format, if possible
p.text.to = {
	
	encoded: function (string) {
		return encodeURIComponent(string);
	},
	safename: function (string) {
		return bl.trim.ends(string.replace(/\s+/g, '')).toLowerCase();
	},

	// Case
	uppercase: function (string) {
		return string.toUpperCase();
	},
	lowercase: function (string) {
		return string.toLowerCase();
	},
	titlecase: function (string) {
		return string.replace(/\w\S*/g, function (text) {
			return text.charAt(0).toUpperCase() + text.substr(1).toLowerCase();
		});
	},

	// Escape for use in regular expression
	pattern: function (string) {
		return string.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
	}

};
