
// Handle status of the view
p.views.status = {

	// Find the current status of the view
	get: function (wrapper) {
		var lifetime = p.conf.views.lifetime;
		var haystack = p._.getClasses(wrapper);
		var status;

		// Find which one of the possible status class names is used
		for (var i = 0; i < lifetime.length; i++) {
			var className = p.conf.views.classNames.status + '_' + lifetime[i];
			if (bl.has.value(className, haystack)) {
				status = lifetime[i];
				break;
			}
		}

		return status;
	},

	// Set the status of the view (remove others)
	set: function (wrapper, method) {
		var lifetime = p.conf.views.lifetime;
		var removed = [];

		// Iterate throgh potential statuses
		for (var i = 0; i < lifetime.length; i++) {
			var className = p.conf.views.classNames.status + '_' + lifetime[i];

			// Add class name
			if (lifetime[i] == method) {
				wrapper.addClass(className);

			// Mark for removal
			} else {
				removed.push(className);
			}
		}

		// Only remove other classes if method was valid (== if it was added and not marked for removal)
		if (lifetime.length > removed.length) {
			wrapper.removeClass(removed.join(' '));
		}

	},

	remove: function (wrapper, method) {
		if (bl.has.value(method, p.conf.views.lifetime)) {
			var className = p.conf.views.classNames.status + '_' + method;
			wrapper.removeClass(className);
		}
	}

};
